#########################################
#########################################
#########################################

#Supplementary data 7: Cluster credibility index

#If you use this script for your publications, don't forget to cite us: Queiroz et al. (XXXX)

#Calculating cluster credibility


#Run first the function:
cc <- function(x,y) {
    x[,c(1,3,4)] <- NULL
    not_equals <- !(colnames(x) %in% c("fraction", y))
    sum(x[rowSums(sapply(x[y],`==`,e2=x[y[1]])) == length(y) &
    rowSums(sapply(x[not_equals],`==`,e2=x[y[1]])) == 0, 1])
}

setwd("path/to/the/file/")

#Upload the speciesDA output
m <- read.table(paste("clusterings.txt", sep=""), header=TRUE, check.names=TRUE)
mincl.names_2 <- colnames(m)[-(1:4)]
cat(mincl.names_2,sep="\n") # I use this list to prepare the combination of samples I want to test in excel.

#Then, test all the clustering hypotheses you wish. Examples:
c1 <- c("sample1", "sample2", "sample3")
c2 <- c("sample1", "sample2")
c3 <- c("sample1", "sample3")
c4 <- c("sample1")


#To calculate CC individually for each cluster hypothesis:
cc(m,c1)
cc(m,c2)
cc(m,c3)
cc(m,c4)

#To calculate CC for all using loop:
my.clusters -> list(c1, c2, c3, c4)

for (i in my.clusters) {
		res <- cc(m,i)
		print(res)
} #Output in the same order as 'my.clusters'

